import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.jdbc.JdbcConnectionSource;
import com.j256.ormlite.support.ConnectionSource;

import java.util.Scanner;

public class AccountApp extends Account {

    // we are using a MySQl database
    private final static String DATABASE_URL = "jdbc:mysql://localhost:3306/orm_lab?useUnicode=true";

    public boolean runner = true;

    Scanner userInput = new Scanner(System.in);

    String name;

    String password;

    private Dao<Account, Integer> accountDao;

    public static void main(String[] args) throws Exception {
        // turn our static method into an instance of Main
        new AccountApp().doMain(args);
    }



    private void doMain(String[] args) throws Exception {
       do{
        ConnectionSource connectionSource = null;
        try {
            // create our data-source for the database
            connectionSource = new JdbcConnectionSource(DATABASE_URL, "root", "");
            // setup our  DAOs
            setupDao(connectionSource);

            System.out.println("Choose a command. ");
            System.out.println( "0 - Create an account \n 1 - Get ID \n 2 - Get Name \n 3 - Get Password \n 4 - Change Name \n 5 - Change Password \n 6 - Έξοδο");
            int x = userInput.nextInt();

            if (x == 0){
                createAccount();
            } else
                if ( x == 1 ){
                readingId();
                } else
                    if ( x == 2 ){
                readName();
                } else
                    if ( x == 3 ){
                readPassword();
                } else
                    if ( x == 4 ){
                changeName();
                } else
                    if ( x == 5 ){
                changePassword();
                } else
                    if ( x == 6 ){
                exit();
                }




            // read, write and delete some data
    //        processData();

        } finally {
            // destroy the data source which should close underlying connections
            if (connectionSource != null) {
                connectionSource.close();
            }



        } } while (runner == true);


    }



    public void createAccount(){
        System.out.println("Enter a name.");
        this.name = userInput.nextLine();
        createAccountPass1();
    }

    public void createAccountPass1(){
        System.out.println("Create a password.");
        this.password = userInput.nextLine();
        createAccountPass2();
    }

    public void createAccountPass2(){
        Account newAccount = new Account(name, password);
        System.out.println("Account created");
    }




    public void readingId(){

        System.out.println(getId());
    }

    public void readName(){

        System.out.println(getName());

    }

    public void readPassword(){

        System.out.println(getPassword());

    }


    public void changeName(){

        this.name = userInput.nextLine();

    }

    public void changePassword(){

        this.password = userInput.nextLine();
    }

    public void exit(){
        runner = false;
        System.out.println("Peace.");
    }





    /**
     * Setup our  DAOs
     */
    private void setupDao(ConnectionSource connectionSource) throws Exception {

        accountDao = DaoManager.createDao(connectionSource, Account.class);

    }






















        private void processData(String userName, String userPassword) throws Exception {
        // create an instance of Account
        String name = userName;
        Account account = new Account(name);

        // persist the account object to the database
        accountDao.create(account);

        int id = account.getId();
        System.out.println(id);

        // assign a password
        account.setPassword(userPassword);

        // update the database after changing the object
        accountDao.update(account);

        // delete the account

       //accountDao.deleteById(id);
    }

}